-- Block RAM 


library IEEE;
use IEEE.std_logic_1164.all;
use IEEE.std_logic_unsigned.all;

 
entity mem is 
  generic( awidth: integer:= 9; -- address width
           dwidth: integer:= 8); -- data width
  port (clk: in std_logic;
    we: in std_logic; -- write enable
 	adr : in std_logic_vector(awidth-1 downto 0); 
	din: in std_logic_vector(dwidth-1 downto 0);
	dout: out std_logic_vector(dwidth-1 downto 0));
 end mem; 
 
architecture brama_arch of mem is 
 --signal zero: std_logic_vector(dwidth-1 downto 0):= (others=>'0'); --needed only for simulation
 type ram_type is array (2**awidth-1 downto 0) of std_logic_vector (dwidth-1 downto 0); 
 signal RAM : ram_type; --:= (others=>zero); -- needed only for simulation (zero assigment)
 signal read_adr : std_logic_vector(awidth-1 downto 0);
 
 begin
 process (clk) 
 begin 
 	if (clk'event and clk = '1') then  
 		if we='1' then 
 			RAM(conv_integer(adr)) <= din; 
 		end if; 
 		read_adr <= adr; 
 	end if; 
 end process; 
 
  dout <= RAM(conv_integer(read_adr));

 end brama_arch;
